# Class Frontmatter

java.lang.Object
com.google.adk.JsonBaseModel
com.google.adk.skills.Frontmatter

public abstract class Frontmatter extends JsonBaseModel
Frontmatter represents the YAML metadata at the top of a SKILL.md file. For more details, see https://agentskills.io/specification#frontmatter.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `Frontmatter.Builder`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Frontmatter()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract Optional<String>`
  `allowedTools()`
  A space-delimited list of tools that are pre-approved to run.
  `static Frontmatter.Builder`
  `builder()`
  `abstract Optional<String>`
  `compatibility()`
  Compatibility information for the skill.
  `abstract String`
  `description()`
  What the skill does and when the model should use it.
  `abstract Optional<String>`
  `license()`
  License for the skill.
  `abstract com.google.common.collect.ImmutableMap<String,Object>`
  `metadata()`
  Key-value pairs for client-specific properties.
  `abstract String`
  `name()`
  Skill name in kebab-case.
  `String`
  `toXml()`

  ### Methods inherited from class JsonBaseModel

  `fromJsonNode, fromJsonString, getMapper, toJson, toJsonNode, toJsonString`
  Modifier and Type
  Method
  Description
  `static <T extends JsonBaseModel>
  T`
  `fromJsonNode(com.fasterxml.jackson.databind.JsonNode jsonNode, Class<T> clazz)`
  Deserializes a JsonNode to an object of the given type.
  `static <T extends JsonBaseModel>
  T`
  `fromJsonString(String jsonString, Class<T> clazz)`
  Deserializes a Json string to an object of the given type.
  `static com.fasterxml.jackson.databind.ObjectMapper`
  `getMapper()`
  Returns the mutable ObjectMapper instance used by ADK.
  `String`
  `toJson()`
  Serializes this object (i.e., the ObjectMappper instance used by ADK) to a Json string.
  `protected static com.fasterxml.jackson.databind.JsonNode`
  `toJsonNode(Object object)`
  Serializes an object to a JsonNode.
  `static String`
  `toJsonString(Object object)`
  Serializes an object to a Json string.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Frontmatter

    public Frontmatter()

- ## Method Details

  - ### name

    public abstract String name()
    Skill name in kebab-case.

  - ### description

    public abstract String description()
    What the skill does and when the model should use it.

  - ### license

    public abstract Optional<String> license()
    License for the skill.

  - ### compatibility

    public abstract Optional<String> compatibility()
    Compatibility information for the skill.

  - ### allowedTools

    public abstract Optional<String> allowedTools()
    A space-delimited list of tools that are pre-approved to run.

  - ### metadata

    public abstract com.google.common.collect.ImmutableMap<String,Object> metadata()
    Key-value pairs for client-specific properties.

  - ### toXml

    public String toXml()

  - ### builder

    public static Frontmatter.Builder builder()